const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AssignmentsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const assignments = await db.assignments.create(
      {
        id: data.id || undefined,

        title: data.title || null,
        description: data.description || null,
        due_date: data.due_date || null,
        attachment_url: data.attachment_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await assignments.setTeacher(data.teacher || null, {
      transaction,
    });

    await assignments.setSubject(data.subject || null, {
      transaction,
    });

    await assignments.setSchools(data.schools || null, {
      transaction,
    });

    return assignments;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const assignmentsData = data.map((item, index) => ({
      id: item.id || undefined,

      title: item.title || null,
      description: item.description || null,
      due_date: item.due_date || null,
      attachment_url: item.attachment_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const assignments = await db.assignments.bulkCreate(assignmentsData, {
      transaction,
    });

    // For each item created, replace relation files

    return assignments;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const assignments = await db.assignments.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.title !== undefined) updatePayload.title = data.title;

    if (data.description !== undefined)
      updatePayload.description = data.description;

    if (data.due_date !== undefined) updatePayload.due_date = data.due_date;

    if (data.attachment_url !== undefined)
      updatePayload.attachment_url = data.attachment_url;

    updatePayload.updatedById = currentUser.id;

    await assignments.update(updatePayload, { transaction });

    if (data.teacher !== undefined) {
      await assignments.setTeacher(
        data.teacher,

        { transaction },
      );
    }

    if (data.subject !== undefined) {
      await assignments.setSubject(
        data.subject,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await assignments.setSchools(
        data.schools,

        { transaction },
      );
    }

    return assignments;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const assignments = await db.assignments.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of assignments) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of assignments) {
        await record.destroy({ transaction });
      }
    });

    return assignments;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const assignments = await db.assignments.findByPk(id, options);

    await assignments.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await assignments.destroy({
      transaction,
    });

    return assignments;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const assignments = await db.assignments.findOne(
      { where },
      { transaction },
    );

    if (!assignments) {
      return assignments;
    }

    const output = assignments.get({ plain: true });

    output.assignment_submissions_assignment =
      await assignments.getAssignment_submissions_assignment({
        transaction,
      });

    output.teacher = await assignments.getTeacher({
      transaction,
    });

    output.subject = await assignments.getSubject({
      transaction,
    });

    output.schools = await assignments.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.teachers,
        as: 'teacher',

        where: filter.teacher
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.teacher
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  full_name: {
                    [Op.or]: filter.teacher
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.subjects,
        as: 'subject',

        where: filter.subject
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.subject
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.subject
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.title) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('assignments', 'title', filter.title),
        };
      }

      if (filter.description) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'assignments',
            'description',
            filter.description,
          ),
        };
      }

      if (filter.attachment_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'assignments',
            'attachment_url',
            filter.attachment_url,
          ),
        };
      }

      if (filter.due_dateRange) {
        const [start, end] = filter.due_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            due_date: {
              ...where.due_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            due_date: {
              ...where.due_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.assignments.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('assignments', 'title', query),
        ],
      };
    }

    const records = await db.assignments.findAll({
      attributes: ['id', 'title'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['title', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.title,
    }));
  }
};
